package com.sun.jndi.url.dns;

import javax.naming.NamingException;
import javax.naming.CompositeName;
import com.sun.jndi.dns.DnsContextFactory;
import java.net.MalformedURLException;
import javax.naming.InvalidNameException;
import com.sun.jndi.dns.DnsUrl;
import javax.naming.spi.ResolveResult;
import java.util.Hashtable;
import com.sun.jndi.toolkit.url.GenericURLDirContext;

public class dnsURLContext extends GenericURLDirContext
{
    public dnsURLContext(Hashtable<?, ?> env) {
        super(env);
    }
    
    @Override
    protected ResolveResult getRootURLContext(String url, Hashtable<?, ?> env) throws NamingException {
        DnsUrl dnsUrl;
        try {
            dnsUrl = new DnsUrl(url);
        }
        catch (MalformedURLException ex) {
            throw new InvalidNameException(ex.getMessage());
        }
        return new ResolveResult(DnsContextFactory.getContext(".", new DnsUrl[] { dnsUrl }, env), new CompositeName().add(dnsUrl.getDomain()));
    }
}
